<!DOCTYPE html>
<html>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1">
<title>Task 35.10 -List of users</title>
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<style>

  .div-title {
    font-size: 40px;
    height: 80px;
    color: rgb(0, 195, 255);
    text-align: center;
    margin-top: 50px;
  }

  .div-name-filter {
    height: 100px;
    align-items: center;
    margin-left: 135px;
    margin-right: 135px;
    background-color: rgb(235, 235, 235);
  }

  .div-table {
    margin-top: 40px;
    margin-bottom: 50px;
    padding-left: 150px;
    padding-right: 150px;
  }

   .div-head {
    text-align: center;
  }
</style>

<body>

  <div class="container-fluid">
    <div  class="div-title"><b>LIST OF USERS</b></div>
    <div class="row div-name-filter">
      <div class="col-sm-4 text-right">
        <label>Name:</label>
      </div>
      <div class="col-sm-4 text-left">
        <input id="name-input" class="form-control" type="text" placeholder="...">
      </div>
      <div>
        <a id="user-filter-btn" type="button" class="btn btn-primary" style="color: white;">User Filter</a>
      </div>
    </div>

  </div>

  <div class="div-table">
    <table id="user-table" class="table table-bordered table-hover table-striped ">
      <thead>
        <tr class="div-head">
          <th>No.</th>
          <th>Name</th>
          <th>Username</th>
          <th>Email</th>
          <th>Address</th>
          <th>Zipcode</th>
          <th>Phone</th>
          <th>Company</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>
         </tbody>
    </table>
  </div>


<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    var gBASE_URL = "https://jsonplaceholder.typicode.com/users/";

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  
    //load the data of users
    $(document).ready(loadUserData);

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  
    //function on loading data of the users
    function loadUserData(){

      //call API for getting the comments' list
      $.ajax ({
            url: gBASE_URL,
            type: "GET",
            success: function(res){
              console.log(res);
              loadDataToTable(res);
            },
            error: function(ajaxContext){
              console.log(ajaxContext);
            },
          });
    }
  
  //function for loading the data to table
  function loadDataToTable(paramData){

    var vTable = $("#user-table");
    
    for (var bI=0; bI < paramData.length; bI++){
      //create a row of the table
      var vNewRow = $("<tr>").appendTo(vTable);
            
      //create cells of the rows
      $("<td>", {html: paramData[bI].id}).attr("class", "text-center").appendTo(vNewRow);
      $("<td>", {html: paramData[bI].name}).appendTo(vNewRow);
      $("<td>", {html: paramData[bI].username}).appendTo(vNewRow);
      $("<td>", {html: paramData[bI].email}).appendTo(vNewRow);

      $("<td>")
        .html(paramData[bI].address.suite + "," + paramData[bI].address.street + "," + paramData[bI].address.city)
        .appendTo(vNewRow);
    
      $("<td>", {html: paramData[bI].address.zipcode}).appendTo(vNewRow);
      $("<td>", {html: paramData[bI].phone}).appendTo(vNewRow);
      $("<td>", {html: paramData[bI].company.name}).appendTo(vNewRow);
         
      //create Detail Button in the action column
      var vAction = $("<td>").appendTo(vNewRow);
      var vDetailBtn = $("<button>")
      .html("Detail")
      .attr("class", "btn btn-warning btn-detail")
      .data("id", paramData[bI].id)
      .appendTo(vAction);
      //add click event for the Detail Button  
      vDetailBtn.click(onDetailBtnClick);
    }
  }

  //add event for Detail Button
  function onDetailBtnClick(paramData){
    
    console.log("%cUSER'S ID: ", "color:orange", $(paramData.currentTarget).data("id"));

    //add query string and access User Detail
    const vUSER_DETAIL = "file:///C:/Users/hphat/Desktop/J2232/2023-02-28/Task%2035%20-%20User's%20Detail.html";
    var vID = paramData.currentTarget;
    var vUrlToSideOpen = vUSER_DETAIL + "?" + "id=" + $(vID).data("id");
    window.location.href = vUrlToSideOpen;

  };
 
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  



</script>

</body>

</html>
